var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Attribute, ChangeDetectionStrategy, ChangeDetectorRef, Component, ContentChild, ContentChildren, ElementRef, EventEmitter, forwardRef, HostBinding, HostListener, Inject, InjectionToken, Input, Output, QueryList, TemplateRef, ViewChild, ViewEncapsulation } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { debounceTime, filter, map, startWith, takeUntil, tap } from 'rxjs/operators';
import { merge, Subject } from 'rxjs';
import { NgFooterTemplateDirective, NgHeaderTemplateDirective, NgLabelTemplateDirective, NgLoadingSpinnerTemplateDirective, NgLoadingTextTemplateDirective, NgMultiLabelTemplateDirective, NgNotFoundTemplateDirective, NgOptgroupTemplateDirective, NgOptionTemplateDirective, NgTagTemplateDirective, NgTypeToSearchTemplateDirective } from './select.directive';
import { isDefined, isFunction, isObject, isPromise, newId } from './select.utils';
import { SelectItems } from './select.items';
import { SelectDropdown } from './select.dropdown';
import { SelectOption } from './select.option';
import { NgSelectConfig } from './select.config';
import { KeyCode, SelectService } from './select.service';
export var SELECTION_MODEL_FACTORY = new InjectionToken('hi-select-selection-model');
var SelectComponent = (function () {
    function SelectComponent(classes, autoFocus, config, newSelectionModel, _elementRef, _cd) {
        var _this = this;
        this.classes = classes;
        this.autoFocus = autoFocus;
        this._cd = _cd;
        this.markFirst = true;
        this.dropdownPosition = 'auto';
        this.loading = false;
        this.closeOnSelect = true;
        this.hideSelected = false;
        this.selectOnTab = false;
        this.bufferAmount = 4;
        this.selectableGroup = false;
        this.selectableGroupAsModel = true;
        this.searchFn = null;
        this.trackByFn = null;
        this.clearOnBackspace = true;
        this.labelForId = null;
        this.inputAttrs = {};
        this.readonly = false;
        this.multiple = false;
        this.addTag = false;
        this.searchable = true;
        this.clearable = true;
        this.isOpen = false;
        this.blurEvent = new EventEmitter();
        this.focusEvent = new EventEmitter();
        this.changeEvent = new EventEmitter();
        this.openEvent = new EventEmitter();
        this.closeEvent = new EventEmitter();
        this.searchEvent = new EventEmitter();
        this.clearEvent = new EventEmitter();
        this.addEvent = new EventEmitter();
        this.removeEvent = new EventEmitter();
        this.scroll = new EventEmitter();
        this.scrollToEnd = new EventEmitter();
        this.viewPortItems = [];
        this.searchTerm = null;
        this.dropdownId = newId();
        this.escapeHTML = true;
        this._defaultLabel = 'label';
        this._pressedKeys = [];
        this._destroy$ = new Subject();
        this._keyPress$ = new Subject();
        this._isComposing = false;
        this._items = [];
        this.keyDownFn = function (_) { return true; };
        this.clearItem = function (item) {
            var option = _this.selectedItems.find(function (x) { return x.value === item; });
            _this.unselect(option);
        };
        this.trackByOption = function (_, item) {
            if (_this.trackByFn) {
                return _this.trackByFn(item.value);
            }
            return item;
        };
        this._onChange = function (_) {
        };
        this._onTouched = function () {
        };
        this._mergeGlobalConfig(config);
        this.itemsList = new SelectItems(this, newSelectionModel());
        this.element = _elementRef.nativeElement;
    }
    SelectComponent_1 = SelectComponent;
    Object.defineProperty(SelectComponent.prototype, "filtered", {
        get: function () {
            return (!!this.searchTerm && this.searchable || this._isComposing);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (value) {
            this._itemsAreUsed = true;
            this._items = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "disabled", {
        get: function () {
            return this.readonly || this._disabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "compareWith", {
        get: function () {
            return this._compareWith;
        },
        set: function (fn) {
            if (!isFunction(fn)) {
                throw Error('`compareWith` must be a function.');
            }
            this._compareWith = fn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "clearSearchOnAdd", {
        get: function () {
            return isDefined(this._clearSearchOnAdd) ? this._clearSearchOnAdd : this.closeOnSelect;
        },
        set: function (value) {
            this._clearSearchOnAdd = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "selectedItems", {
        get: function () {
            return this.itemsList.selectedItems;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "selectedValues", {
        get: function () {
            return this.selectedItems.map(function (x) { return x.value; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hasValue", {
        get: function () {
            return this.selectedItems.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "currentPanelPosition", {
        get: function () {
            if (this.dropdownPanel) {
                return this.dropdownPanel.currentPosition;
            }
            return undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "showAddTag", {
        get: function () {
            var term = this.searchTerm && this.searchTerm.trim();
            if (!term) {
                return false;
            }
            term = term.toLowerCase();
            return this.addTag &&
                (!this.itemsList.filteredItems.some(function (x) { return x.label.toLowerCase() === term; }) &&
                    (!this.hideSelected && this.isOpen || !this.selectedItems.some(function (x) { return x.label.toLowerCase() === term; }))) &&
                !this.loading;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "_isTypeahead", {
        get: function () {
            return this.typeahead && this.typeahead.observers.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.ngOnInit = function () {
        this._handleKeyPresses();
        this._setInputAttributes();
    };
    SelectComponent.prototype.ngOnChanges = function (changes) {
        if (changes.multiple) {
            this.itemsList.clearSelected();
        }
        if (changes.items) {
            this._setItems(changes.items.currentValue || []);
        }
        if (changes.isOpen) {
            this._manualOpen = isDefined(changes.isOpen.currentValue);
        }
    };
    SelectComponent.prototype.ngAfterViewInit = function () {
        if (!this._itemsAreUsed) {
            this.escapeHTML = false;
            this._setItemsFromNgOptions();
        }
        if (isDefined(this.autoFocus)) {
            this.focus();
        }
    };
    SelectComponent.prototype.ngOnDestroy = function () {
        this._destroy$.next();
        this._destroy$.complete();
    };
    SelectComponent.prototype.handleKeyDown = function ($event) {
        var keyCode = KeyCode[$event.which];
        if (keyCode) {
            if (this.keyDownFn($event) === false) {
                return;
            }
            this.handleKeyCode($event);
        }
        else if ($event.key && $event.key.length === 1) {
            this._keyPress$.next($event.key.toLocaleLowerCase());
        }
    };
    SelectComponent.prototype.handleKeyCode = function ($event) {
        switch ($event.which) {
            case KeyCode.ArrowDown:
                this._handleArrowDown($event);
                break;
            case KeyCode.ArrowUp:
                this._handleArrowUp($event);
                break;
            case KeyCode.Space:
                this._handleSpace($event);
                break;
            case KeyCode.Enter:
                this._handleEnter($event);
                break;
            case KeyCode.Tab:
                this._handleTab($event);
                break;
            case KeyCode.Esc:
                this.close();
                $event.preventDefault();
                break;
            case KeyCode.Backspace:
                this._handleBackspace();
                break;
        }
    };
    SelectComponent.prototype.handleMousedown = function ($event) {
        var target = $event.target;
        if (target.tagName !== 'INPUT') {
            $event.preventDefault();
        }
        if (target.classList.contains('ng-clear-wrapper')) {
            this.handleClearClick();
            return;
        }
        if (target.classList.contains('ng-arrow-wrapper')) {
            this.handleArrowClick();
            return;
        }
        if (target.classList.contains('ng-value-icon')) {
            return;
        }
        if (!this.focused) {
            this.focus();
        }
        if (this.searchable) {
            this.open();
        }
        else {
            this.toggle();
        }
    };
    SelectComponent.prototype.handleArrowClick = function () {
        if (this.isOpen) {
            this.close();
        }
        else {
            this.open();
        }
    };
    SelectComponent.prototype.handleClearClick = function () {
        if (this.hasValue) {
            this.itemsList.clearSelected(true);
            this._updateNgModel();
        }
        this._clearSearch();
        this.focus();
        this.clearEvent.emit();
        this._onSelectionChanged();
    };
    SelectComponent.prototype.clearModel = function () {
        if (!this.clearable) {
            return;
        }
        this.itemsList.clearSelected();
        this._updateNgModel();
    };
    SelectComponent.prototype.writeValue = function (value) {
        this.itemsList.clearSelected();
        this._handleWriteValue(value);
        this._cd.markForCheck();
    };
    SelectComponent.prototype.registerOnChange = function (fn) {
        this._onChange = fn;
    };
    SelectComponent.prototype.registerOnTouched = function (fn) {
        this._onTouched = fn;
    };
    SelectComponent.prototype.setDisabledState = function (state) {
        this._disabled = state;
        this._cd.markForCheck();
    };
    SelectComponent.prototype.toggle = function () {
        if (!this.isOpen) {
            this.open();
        }
        else {
            this.close();
        }
    };
    SelectComponent.prototype.open = function () {
        if (this.disabled || this.isOpen || this.itemsList.maxItemsSelected || this._manualOpen) {
            return;
        }
        if (!this._isTypeahead && !this.addTag && this.itemsList.noItemsToSelect) {
            return;
        }
        this.isOpen = true;
        this.itemsList.markSelectedOrDefault(this.markFirst);
        this.openEvent.emit();
        if (!this.searchTerm) {
            this.focus();
        }
        this.detectChanges();
    };
    SelectComponent.prototype.close = function () {
        if (!this.isOpen || this._manualOpen) {
            return;
        }
        this.isOpen = false;
        this._clearSearch();
        this.itemsList.unmarkItem();
        this._onTouched();
        this.closeEvent.emit();
        this._cd.markForCheck();
    };
    SelectComponent.prototype.toggleItem = function (item) {
        if (!item || item.disabled || this.disabled) {
            return;
        }
        if (this.multiple && item.selected) {
            this.unselect(item);
        }
        else {
            this.select(item);
        }
        this._onSelectionChanged();
    };
    SelectComponent.prototype.select = function (item) {
        if (!item.selected) {
            this.itemsList.select(item);
            if (this.clearSearchOnAdd) {
                this._clearSearch();
            }
            this._updateNgModel();
            if (this.multiple) {
                this.addEvent.emit(item.value);
            }
        }
        if (this.closeOnSelect || this.itemsList.noItemsToSelect) {
            this.close();
        }
    };
    SelectComponent.prototype.focus = function () {
        this.searchInput.nativeElement.focus();
    };
    SelectComponent.prototype.blur = function () {
        this.searchInput.nativeElement.blur();
    };
    SelectComponent.prototype.unselect = function (item) {
        if (!item) {
            return;
        }
        this.itemsList.unselect(item);
        this.focus();
        this._updateNgModel();
        this.removeEvent.emit(item);
    };
    SelectComponent.prototype.selectTag = function () {
        var _this = this;
        var _a;
        var tag;
        if (isFunction(this.addTag)) {
            tag = this.addTag(this.searchTerm);
        }
        else {
            tag = this._primitive ? this.searchTerm : (_a = {}, _a[this.bindLabel] = this.searchTerm, _a);
        }
        var handleTag = function (item) { return _this._isTypeahead || !_this.isOpen ? _this.itemsList.mapItem(item, null) : _this.itemsList.addItem(item); };
        if (isPromise(tag)) {
            tag.then(function (item) { return _this.select(handleTag(item)); }).catch(function () {
            });
        }
        else if (tag) {
            this.select(handleTag(tag));
        }
    };
    SelectComponent.prototype.showClear = function () {
        return this.clearable && (this.hasValue || this.searchTerm) && !this.disabled;
    };
    SelectComponent.prototype.showNoItemsFound = function () {
        var empty = this.itemsList.filteredItems.length === 0;
        return ((empty && !this._isTypeahead && !this.loading) ||
            (empty && this._isTypeahead && this.searchTerm && !this.loading)) &&
            !this.showAddTag;
    };
    SelectComponent.prototype.showTypeToSearch = function () {
        var empty = this.itemsList.filteredItems.length === 0;
        return empty && this._isTypeahead && !this.searchTerm && !this.loading;
    };
    SelectComponent.prototype.onCompositionStart = function () {
        this._isComposing = true;
    };
    SelectComponent.prototype.onCompositionEnd = function (term) {
        this._isComposing = false;
        this.filter(term);
    };
    SelectComponent.prototype.filter = function (term) {
        if (this._isComposing) {
            return;
        }
        this._changeSearch(term);
        if (!this._isTypeahead) {
            this.itemsList.filter(this.searchTerm);
            if (this.isOpen) {
                this.itemsList.markSelectedOrDefault(this.markFirst);
            }
        }
        this.searchEvent.emit({ term: term, items: this.itemsList.filteredItems.map(function (x) { return x.value; }) });
        this.open();
    };
    SelectComponent.prototype.onInputFocus = function ($event) {
        if (this.focused) {
            return;
        }
        this.element.classList.add('hi-select-focused');
        this.focusEvent.emit($event);
        this.focused = true;
    };
    SelectComponent.prototype.onInputBlur = function ($event) {
        this.element.classList.remove('hi-select-focused');
        this.blurEvent.emit($event);
        if (!this.isOpen && !this.disabled) {
            this._onTouched();
        }
        this.focused = false;
    };
    SelectComponent.prototype.onItemHover = function (item) {
        if (item.disabled) {
            return;
        }
        this.itemsList.markItem(item);
    };
    SelectComponent.prototype.detectChanges = function () {
        if (!this._cd.destroyed) {
            this._cd.detectChanges();
        }
    };
    SelectComponent.prototype._setItems = function (items) {
        var firstItem = items[0];
        this.bindLabel = this.bindLabel || this._defaultLabel;
        this._primitive = isDefined(firstItem) ? !isObject(firstItem) : this._primitive || this.bindLabel === this._defaultLabel;
        this.itemsList.setItems(items);
        if (items.length > 0 && this.hasValue) {
            this.itemsList.mapSelectedItems();
        }
        if (this.isOpen && isDefined(this.searchTerm) && !this._isTypeahead) {
            this.itemsList.filter(this.searchTerm);
        }
        if (this._isTypeahead || this.isOpen) {
            this.itemsList.markSelectedOrDefault(this.markFirst);
        }
    };
    SelectComponent.prototype._setItemsFromNgOptions = function () {
        var _this = this;
        var mapNgOptions = function (options) {
            _this.items = options.map(function (option) { return ({
                $ngOptionValue: option.value,
                $ngOptionLabel: option.elementRef.nativeElement.innerHTML,
                disabled: option.disabled
            }); });
            _this.itemsList.setItems(_this.items);
            if (_this.hasValue) {
                _this.itemsList.mapSelectedItems();
            }
            _this.detectChanges();
        };
        var handleOptionChange = function () {
            var changedOrDestroyed = merge(_this.ngOptions.changes, _this._destroy$);
            merge.apply(void 0, _this.ngOptions.map(function (option) { return option.stateChange$; })).pipe(takeUntil(changedOrDestroyed))
                .subscribe(function (option) {
                var item = _this.itemsList.findItem(option.value);
                item.disabled = option.disabled;
                item.label = option.label || item.label;
                _this._cd.detectChanges();
            });
        };
        this.ngOptions.changes
            .pipe(startWith(this.ngOptions), takeUntil(this._destroy$))
            .subscribe(function (options) {
            _this.bindLabel = _this._defaultLabel;
            mapNgOptions(options);
            handleOptionChange();
        });
    };
    SelectComponent.prototype._isValidWriteValue = function (value) {
        var _this = this;
        if (!isDefined(value) || (this.multiple && value === '') || Array.isArray(value) && value.length === 0) {
            return false;
        }
        var validateBinding = function (item) {
            if (!isDefined(_this.compareWith) && isObject(item) && _this.bindValue) {
                return false;
            }
            return true;
        };
        if (this.multiple) {
            if (!Array.isArray(value)) {
                return false;
            }
            return value.every(function (item) { return validateBinding(item); });
        }
        else {
            return validateBinding(value);
        }
    };
    SelectComponent.prototype._handleWriteValue = function (ngModel) {
        var _this = this;
        if (!this._isValidWriteValue(ngModel)) {
            return;
        }
        var select = function (val) {
            var _a;
            var item = _this.itemsList.findItem(val);
            if (item) {
                _this.itemsList.select(item);
            }
            else {
                var isValObject = isObject(val);
                var isPrimitive = !isValObject && !_this.bindValue;
                if ((isValObject || isPrimitive)) {
                    _this.itemsList.select(_this.itemsList.mapItem(val, null));
                }
                else if (_this.bindValue) {
                    item = (_a = {},
                        _a[_this.bindLabel] = null,
                        _a[_this.bindValue] = val,
                        _a);
                    _this.itemsList.select(_this.itemsList.mapItem(item, null));
                }
            }
        };
        if (this.multiple) {
            ngModel.forEach(function (item) { return select(item); });
        }
        else {
            select(ngModel);
        }
    };
    SelectComponent.prototype._handleKeyPresses = function () {
        var _this = this;
        if (this.searchable) {
            return;
        }
        this._keyPress$
            .pipe(takeUntil(this._destroy$), tap(function (letter) { return _this._pressedKeys.push(letter); }), debounceTime(200), filter(function () { return _this._pressedKeys.length > 0; }), map(function () { return _this._pressedKeys.join(''); }))
            .subscribe(function (term) {
            var item = _this.itemsList.findByLabel(term);
            if (item) {
                if (_this.isOpen) {
                    _this.itemsList.markItem(item);
                    _this._cd.markForCheck();
                }
                else {
                    _this.select(item);
                }
            }
            _this._pressedKeys = [];
        });
    };
    SelectComponent.prototype._setInputAttributes = function () {
        var input = this.searchInput.nativeElement;
        var attributes = __assign({ type: 'text', autocorrect: 'off', autocapitalize: 'off', autocomplete: this.labelForId ? 'off' : this.dropdownId }, this.inputAttrs);
        for (var _i = 0, _a = Object.keys(attributes); _i < _a.length; _i++) {
            var key = _a[_i];
            input.setAttribute(key, attributes[key]);
        }
    };
    SelectComponent.prototype._updateNgModel = function () {
        var model = [];
        for (var _i = 0, _a = this.selectedItems; _i < _a.length; _i++) {
            var item = _a[_i];
            if (this.bindValue) {
                var value = null;
                if (item.children) {
                    var groupKey = this.groupValue ? this.bindValue : this.groupBy;
                    value = item.value[groupKey || this.groupBy];
                }
                else {
                    value = this.itemsList.resolveNested(item.value, this.bindValue);
                }
                model.push(value);
            }
            else {
                model.push(item.value);
            }
        }
        var selected = this.selectedItems.map(function (x) { return x.value; });
        if (this.multiple) {
            this._onChange(model);
            this.changeEvent.emit(selected);
        }
        else {
            this._onChange(isDefined(model[0]) ? model[0] : null);
            this.changeEvent.emit(selected[0]);
        }
        this._cd.markForCheck();
    };
    SelectComponent.prototype._clearSearch = function () {
        if (!this.searchTerm) {
            return;
        }
        this._changeSearch(null);
        this.itemsList.resetFilteredItems();
    };
    SelectComponent.prototype._changeSearch = function (searchTerm) {
        this.searchTerm = searchTerm;
        if (this._isTypeahead) {
            this.typeahead.next(searchTerm);
        }
    };
    SelectComponent.prototype._scrollToMarked = function () {
        if (!this.isOpen || !this.dropdownPanel) {
            return;
        }
        this.dropdownPanel.scrollTo(this.itemsList.markedItem);
    };
    SelectComponent.prototype._scrollToTag = function () {
        if (!this.isOpen || !this.dropdownPanel) {
            return;
        }
        this.dropdownPanel.scrollToTag();
    };
    SelectComponent.prototype._onSelectionChanged = function () {
        if (this.isOpen && this.multiple && this.appendTo) {
            this._cd.detectChanges();
            this.dropdownPanel.adjustPosition();
        }
    };
    SelectComponent.prototype._handleTab = function ($event) {
        if (this.isOpen === false && !this.addTag) {
            return;
        }
        if (this.selectOnTab) {
            if (this.itemsList.markedItem) {
                this.toggleItem(this.itemsList.markedItem);
                $event.preventDefault();
            }
            else if (this.showAddTag) {
                this.selectTag();
                $event.preventDefault();
            }
            else {
                this.close();
            }
        }
        else {
            this.close();
        }
    };
    SelectComponent.prototype._handleEnter = function ($event) {
        if (this.isOpen || this._manualOpen) {
            if (this.itemsList.markedItem) {
                this.toggleItem(this.itemsList.markedItem);
            }
            else if (this.showAddTag) {
                this.selectTag();
            }
        }
        else if (this.openOnEnter) {
            this.open();
        }
        else {
            return;
        }
        $event.preventDefault();
    };
    SelectComponent.prototype._handleSpace = function ($event) {
        if (this.isOpen || this._manualOpen) {
            return;
        }
        this.open();
        $event.preventDefault();
    };
    SelectComponent.prototype._handleArrowDown = function ($event) {
        if (this._nextItemIsTag(+1)) {
            this.itemsList.unmarkItem();
            this._scrollToTag();
        }
        else {
            this.itemsList.markNextItem();
            this._scrollToMarked();
        }
        this.open();
        $event.preventDefault();
    };
    SelectComponent.prototype._handleArrowUp = function ($event) {
        if (!this.isOpen) {
            return;
        }
        if (this._nextItemIsTag(-1)) {
            this.itemsList.unmarkItem();
            this._scrollToTag();
        }
        else {
            this.itemsList.markPreviousItem();
            this._scrollToMarked();
        }
        $event.preventDefault();
    };
    SelectComponent.prototype._nextItemIsTag = function (nextStep) {
        var nextIndex = this.itemsList.markedIndex + nextStep;
        return this.addTag && this.searchTerm
            && this.itemsList.markedItem
            && (nextIndex < 0 || nextIndex === this.itemsList.filteredItems.length);
    };
    SelectComponent.prototype._handleBackspace = function () {
        if (this.searchTerm || !this.clearable || !this.clearOnBackspace || !this.hasValue) {
            return;
        }
        if (this.multiple) {
            this.unselect(this.itemsList.lastSelectedItem);
        }
        else {
            this.clearModel();
        }
    };
    SelectComponent.prototype._mergeGlobalConfig = function (config) {
        this.placeholder = this.placeholder || config.placeholder;
        this.notFoundText = this.notFoundText || config.notFoundText;
        this.typeToSearchText = this.typeToSearchText || config.typeToSearchText;
        this.addTagText = this.addTagText || config.addTagText;
        this.loadingText = this.loadingText || config.loadingText;
        this.clearAllText = this.clearAllText || config.clearAllText;
        this.virtualScroll = isDefined(this.virtualScroll)
            ? this.virtualScroll
            : isDefined(config.disableVirtualScroll) ? !config.disableVirtualScroll : false;
        this.openOnEnter = isDefined(this.openOnEnter) ? this.openOnEnter : config.openOnEnter;
        this.appendTo = this.appendTo || config.appendTo;
        this.bindValue = this.bindValue || config.bindValue;
    };
    var SelectComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "bindLabel", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "bindValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "markFirst", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "placeholder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "notFoundText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "typeToSearchText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "addTagText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "loadingText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "clearAllText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "dropdownPosition", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "appendTo", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "loading", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "closeOnSelect", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hideSelected", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "selectOnTab", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectComponent.prototype, "openOnEnter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], SelectComponent.prototype, "maxSelectedItems", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "groupBy", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], SelectComponent.prototype, "groupValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "bufferAmount", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectComponent.prototype, "virtualScroll", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "selectableGroup", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "selectableGroupAsModel", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "searchFn", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "trackByFn", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "clearOnBackspace", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "labelForId", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "inputAttrs", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], SelectComponent.prototype, "tabIndex", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "readonly", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-typeahead'),
        __metadata("design:type", Subject)
    ], SelectComponent.prototype, "typeahead", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-multiple'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "multiple", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-taggable'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "addTag", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-searchable'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "searchable", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-clearable'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "clearable", void 0);
    __decorate([
        Input(), HostBinding('class.hi-select-opened'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "isOpen", void 0);
    __decorate([
        Output('blur'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "blurEvent", void 0);
    __decorate([
        Output('focus'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "focusEvent", void 0);
    __decorate([
        Output('change'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "changeEvent", void 0);
    __decorate([
        Output('open'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "openEvent", void 0);
    __decorate([
        Output('close'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "closeEvent", void 0);
    __decorate([
        Output('search'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "searchEvent", void 0);
    __decorate([
        Output('clear'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "clearEvent", void 0);
    __decorate([
        Output('add'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "addEvent", void 0);
    __decorate([
        Output('remove'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "removeEvent", void 0);
    __decorate([
        Output('scroll'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "scroll", void 0);
    __decorate([
        Output('scrollToEnd'),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "scrollToEnd", void 0);
    __decorate([
        ContentChild(NgOptionTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "optionTemplate", void 0);
    __decorate([
        ContentChild(NgOptgroupTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "optgroupTemplate", void 0);
    __decorate([
        ContentChild(NgLabelTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "labelTemplate", void 0);
    __decorate([
        ContentChild(NgMultiLabelTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "multiLabelTemplate", void 0);
    __decorate([
        ContentChild(NgHeaderTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "headerTemplate", void 0);
    __decorate([
        ContentChild(NgFooterTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "footerTemplate", void 0);
    __decorate([
        ContentChild(NgNotFoundTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "notFoundTemplate", void 0);
    __decorate([
        ContentChild(NgTypeToSearchTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "typeToSearchTemplate", void 0);
    __decorate([
        ContentChild(NgLoadingTextTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "loadingTextTemplate", void 0);
    __decorate([
        ContentChild(NgTagTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "tagTemplate", void 0);
    __decorate([
        ContentChild(NgLoadingSpinnerTemplateDirective, { read: TemplateRef, static: false }),
        __metadata("design:type", TemplateRef)
    ], SelectComponent.prototype, "loadingSpinnerTemplate", void 0);
    __decorate([
        ViewChild(forwardRef(function () { return SelectDropdown; }), { static: false }),
        __metadata("design:type", SelectDropdown)
    ], SelectComponent.prototype, "dropdownPanel", void 0);
    __decorate([
        ViewChild('searchInput', { static: true }),
        __metadata("design:type", ElementRef)
    ], SelectComponent.prototype, "searchInput", void 0);
    __decorate([
        ContentChildren(SelectOption, { descendants: true }),
        __metadata("design:type", QueryList)
    ], SelectComponent.prototype, "ngOptions", void 0);
    __decorate([
        HostBinding('class.hi-select-filtered'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], SelectComponent.prototype, "filtered", null);
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], SelectComponent.prototype, "items", null);
    __decorate([
        HostBinding('class.hi-select-disabled'),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], SelectComponent.prototype, "disabled", null);
    __decorate([
        Input(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Function])
    ], SelectComponent.prototype, "compareWith", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], SelectComponent.prototype, "clearSearchOnAdd", null);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "keyDownFn", void 0);
    __decorate([
        HostListener('keydown', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [KeyboardEvent]),
        __metadata("design:returntype", void 0)
    ], SelectComponent.prototype, "handleKeyDown", null);
    SelectComponent = SelectComponent_1 = __decorate([
        Component({
            selector: 'hi-select',
            template: "\n    <div (mousedown)=\"handleMousedown($event)\" [class.ng-has-value]=\"hasValue\" class=\"hi-select-container\"><div class=\"ng-value-container\"><div class=\"ng-placeholder\">{{placeholder}}</div><ng-container *ngIf=\"!multiLabelTemplate && selectedItems.length > 0\"><div *ngFor=\"let item of selectedItems; trackBy: trackByOption\" [class.ng-value-disabled]=\"item.disabled\" class=\"ng-value\"><ng-template #defaultLabelTemplate><span (click)=\"unselect(item);\" aria-hidden=\"true\" class=\"ng-value-icon left\">×</span> <span [escape]=\"escapeHTML\" [ngItemLabel]=\"item.label\" class=\"ng-value-label\"></span></ng-template><ng-template [ngTemplateOutletContext]=\"{ item: item.value, clear: clearItem, label: item.label }\" [ngTemplateOutlet]=\"labelTemplate || defaultLabelTemplate\"></ng-template></div></ng-container><ng-template *ngIf=\"multiLabelTemplate && selectedValues.length > 0\" [ngTemplateOutletContext]=\"{ items: selectedValues, clear: clearItem }\" [ngTemplateOutlet]=\"multiLabelTemplate\"></ng-template><div class=\"ng-input\"><input #searchInput (blur)=\"onInputBlur($event)\" (change)=\"$event.stopPropagation()\" (compositionend)=\"onCompositionEnd(searchInput.value)\" (compositionstart)=\"onCompositionStart()\" (focus)=\"onInputFocus($event)\" (input)=\"filter(searchInput.value)\" [attr.aria-activedescendant]=\"isOpen ? itemsList?.markedItem?.htmlId : null\" [attr.aria-expanded]=\"isOpen\" [attr.aria-owns]=\"isOpen ? dropdownId : null\" [attr.id]=\"labelForId\" [attr.tabindex]=\"tabIndex\" [disabled]=\"disabled\" [readOnly]=\"!searchable || itemsList.maxItemsSelected\" [value]=\"searchTerm ? searchTerm : ''\" role=\"combobox\"></div></div><ng-container *ngIf=\"loading\"><ng-template #defaultLoadingSpinnerTemplate><div class=\"ng-spinner-loader\"></div></ng-template><ng-template [ngTemplateOutlet]=\"loadingSpinnerTemplate || defaultLoadingSpinnerTemplate\"></ng-template></ng-container><span *ngIf=\"showClear()\" class=\"ng-clear-wrapper\" title=\"{{clearAllText}}\"><span aria-hidden=\"true\" class=\"ng-clear\">×</span> </span><span class=\"ng-arrow-wrapper\"><span class=\"ng-arrow\"></span></span></div><ng-dropdown-panel (outsideClick)=\"close()\" (scroll)=\"scroll.emit($event)\" (scrollToEnd)=\"scrollToEnd.emit($event)\" (update)=\"viewPortItems = $event\" *ngIf=\"isOpen\" [appendTo]=\"appendTo\" [bufferAmount]=\"bufferAmount\" [class.hi-select-multiple]=\"multiple\" [filterValue]=\"searchTerm\" [footerTemplate]=\"footerTemplate\" [headerTemplate]=\"headerTemplate\" [id]=\"dropdownId\" [items]=\"itemsList.filteredItems\" [markedItem]=\"itemsList.markedItem\" [ngClass]=\"appendTo ? classes : null\" [position]=\"dropdownPosition\" [virtualScroll]=\"virtualScroll\" class=\"ng-dropdown-panel\"><ng-container><div (click)=\"toggleItem(item)\" (mouseover)=\"onItemHover(item)\" *ngFor=\"let item of viewPortItems; trackBy: trackByOption\" [attr.aria-selected]=\"item.selected\" [attr.id]=\"item?.htmlId\" [attr.role]=\"item.children ? 'group' : 'option'\" [class.ng-optgroup]=\"item.children\" [class.ng-option-child]=\"!!item.parent\" [class.ng-option-disabled]=\"item.disabled\" [class.ng-option-marked]=\"item === itemsList.markedItem\" [class.ng-option-selected]=\"item.selected\" [class.ng-option]=\"!item.children\" class=\"ng-option\"><ng-template #defaultOptionTemplate><span [escape]=\"escapeHTML\" [ngItemLabel]=\"item.label\" class=\"ng-option-label\"></span></ng-template><ng-template [ngTemplateOutletContext]=\"{ item: item.value, item$:item, index: item.index, searchTerm: searchTerm }\" [ngTemplateOutlet]=\"item.children ? (optgroupTemplate || defaultOptionTemplate) : (optionTemplate || defaultOptionTemplate)\"></ng-template></div><div (click)=\"selectTag()\" (mouseover)=\"itemsList.unmarkItem()\" *ngIf=\"showAddTag\" [class.ng-option-marked]=\"!itemsList.markedItem\" class=\"ng-option\" role=\"option\"><ng-template #defaultTagTemplate><span><span class=\"ng-tag-label\">{{addTagText}}</span>\"{{searchTerm}}\"</span></ng-template><ng-template [ngTemplateOutletContext]=\"{ searchTerm: searchTerm }\" [ngTemplateOutlet]=\"tagTemplate || defaultTagTemplate\"></ng-template></div></ng-container><ng-container *ngIf=\"showNoItemsFound()\"><ng-template #defaultNotFoundTemplate><div class=\"ng-option ng-option-disabled\">{{notFoundText}}</div></ng-template><ng-template [ngTemplateOutletContext]=\"{ searchTerm: searchTerm }\" [ngTemplateOutlet]=\"notFoundTemplate || defaultNotFoundTemplate\"></ng-template></ng-container><ng-container *ngIf=\"showTypeToSearch()\"><ng-template #defaultTypeToSearchTemplate><div class=\"ng-option ng-option-disabled\">{{typeToSearchText}}</div></ng-template><ng-template [ngTemplateOutlet]=\"typeToSearchTemplate || defaultTypeToSearchTemplate\"></ng-template></ng-container><ng-container *ngIf=\"loading && itemsList.filteredItems.length === 0\"><ng-template #defaultLoadingTextTemplate><div class=\"ng-option ng-option-disabled\">{{loadingText}}</div></ng-template><ng-template [ngTemplateOutletContext]=\"{ searchTerm: searchTerm }\" [ngTemplateOutlet]=\"loadingTextTemplate || defaultLoadingTextTemplate\"></ng-template></ng-container></ng-dropdown-panel>\n  ",
            styles: ["\n    .hi-select{position:relative;display:block;box-sizing:border-box}.hi-select.hi-select-opened.hi-select-clearable .hi-select-container.ng-has-value:hover .ng-clear-wrapper{opacity:0;pointer-events:none}.hi-select.hi-select-opened.hi-select-clearable .hi-select-container.ng-has-value:hover .ng-arrow-wrapper{opacity:1}.hi-select.hi-select-opened>.hi-select-container{background:#fff;border-color:#3f51b5;box-shadow:0 0 0 2px rgba(24,144,255,.2)}.hi-select.hi-select-opened>.hi-select-container .ng-arrow-wrapper{transform:rotate(180deg);opacity:1}.hi-select.hi-select-focused .hi-select-container{border-color:#3f51b5}.hi-select.hi-select-disabled>.hi-select-container{background-color:#f5f5f5}.hi-select.hi-select-disabled>.hi-select-container:hover{border:1px solid #d9d9d9;cursor:not-allowed}.hi-select.hi-select-disabled>.hi-select-container .ng-value-container .ng-value{color:rgba(0,0,0,.38)}.hi-select .ng-has-value .ng-placeholder{display:none}.hi-select.hi-select-clearable .hi-select-container.ng-has-value:hover .ng-clear-wrapper{opacity:1}.hi-select.hi-select-clearable .hi-select-container.ng-has-value:hover .ng-arrow-wrapper{opacity:0;pointer-events:none}.hi-select .hi-select-container{background-color:#fff;border-radius:4px;border:1px solid #d9d9d9;min-height:32px;align-items:center;transition:all .3s;box-sizing:border-box;padding-right:11px;padding-left:11px;color:#333;cursor:default;display:flex;outline:0;overflow:hidden;position:relative;width:100%}.hi-select .hi-select-container .ng-input{line-height:22px}.hi-select .hi-select-container .ng-input input{color:rgba(255,255,255,.87)}.hi-select .hi-select-container .ng-value-container{align-items:center}.hi-select .hi-select-container .ng-value-container .ng-value{font-size:14px;color:rgba(255,255,255,.87)}.hi-select .hi-select-container .ng-value-container .ng-placeholder{font-size:14px;color:rgba(255,255,255,.87)}.hi-select.hi-select-single.hi-select-opened .hi-select-container .ng-value{opacity:.4}.hi-select.hi-select-single .hi-select-container .ng-value-container .ng-input{top:2px;left:0;padding-left:10px;padding-right:50px}.hi-select.hi-select-multiple.hi-select-disabled>.hi-select-container .ng-value-container .ng-value{background-color:#f5f5f5}.hi-select.hi-select-multiple.hi-select-disabled>.hi-select-container .ng-value-container .ng-value .ng-value-label{padding:0 5px}.hi-select.hi-select-multiple .hi-select-container{min-height:32px;padding-left:5px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container{padding-bottom:3px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value{margin-top:3px;margin-right:4px;font-size:.9em;background-color:#fafafa;border:1px solid #e8e8e8;border-radius:2px;height:24px;line-height:22px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value.ng-value-disabled{background-color:#f5f5f5;color:rgba(0,0,0,.38)}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value.ng-value-disabled .ng-value-label{padding-left:5px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value .ng-value-label{display:inline-block;padding:0 5px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value .ng-value-icon{display:inline-block;padding:0 5px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-placeholder{top:50%;height:20px;margin-top:-10px;margin-left:6px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-input{height:24px;margin-top:3px}.hi-select .ng-clear-wrapper{opacity:0;color:#a6a6a6;background:rgba(0,0,0,.25);width:12px;height:12px;text-align:center;border-radius:12px;vertical-align:middle;transition:color .3s ease;position:absolute;right:13px}.hi-select .ng-clear-wrapper:hover{background:rgba(0,0,0,.45)}.hi-select .ng-clear-wrapper .ng-clear{color:#fff;font-size:9px;position:absolute;left:3px;line-height:12px}.hi-select .ng-spinner-zone{padding:5px 5px 0 0}.hi-select .ng-arrow-wrapper{width:16px;height:26px;transition:transform .3s}.hi-select .ng-arrow-wrapper .ng-arrow{border-style:solid;border-width:.1rem .1rem 0 0;height:8px;width:8px;top:-2px;transform:rotate(135deg);color:rgba(0,0,0,.38)}.ng-dropdown-panel{background-color:#fff;box-shadow:0 2px 8px rgba(0,0,0,.15);border-radius:4px;margin-top:4px;margin-bottom:4px;left:0}.ng-dropdown-panel.hi-select-bottom{top:100%;border-top-color:#f3f3f3}.ng-dropdown-panel.hi-select-top{bottom:100%;border-bottom-color:#f3f3f3}.ng-dropdown-panel .ng-dropdown-header{border-bottom:1px solid #d9d9d9;padding:5px 7px}.ng-dropdown-panel .ng-dropdown-footer{border-top:1px solid #d9d9d9;padding:5px 7px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup{user-select:none;padding:4px 12px;color:rgba(0,0,0,.45);cursor:pointer}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-disabled{cursor:default;color:rgba(0,0,0,.45)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-marked{background-color:#e6f7ff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected{background-color:#fafafa;font-weight:600}.ng-dropdown-panel .ng-dropdown-panel-items .ng-optgroup.ng-option-selected.ng-option-marked{background-color:#e6f7ff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{background-color:#fff;color:rgba(255,255,255,.87);padding:5px 12px;transition:background .3s ease}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option:first-child{border-top-right-radius:4px;border-top-left-radius:4px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option:last-child{border-bottom-right-radius:4px;border-bottom-left-radius:4px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected{background-color:#fafafa;font-weight:600}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected.ng-option-marked{color:rgba(255,255,255,.87);background-color:#e6f7ff}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{background-color:#e6f7ff;color:rgba(255,255,255,.87)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-disabled{color:rgba(0,0,0,.38);cursor:not-allowed}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-child{padding-left:20px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option .ng-option-label{font-size:14px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option .ng-tag-label{font-size:80%;font-weight:400;padding-right:5px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container{padding-bottom:3px;flex-wrap:wrap}.hi-select .hi-select-container .ng-value-container{align-items:center;display:flex;flex:1}.hi-select-container .ng-value-container .ng-placeholder{top:50%;height:20px;margin-top:-10px;margin-left:6px}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-placeholder{position:absolute;z-index:1}.hi-select .hi-select-container .ng-value-container .ng-placeholder{font-size:14px;color:rgba(153,153,153,.65)}.hi-select .ng-has-value .ng-placeholder{display:none}*,::after,::before{box-sizing:border-box}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value{margin-top:3px;margin-right:4px;font-size:.9em;background-color:#fafafa;border:1px solid #e8e8e8;border-radius:2px;height:24px;line-height:22px;white-space:nowrap}.hi-select .hi-select-container .ng-value-container .ng-value{font-size:14px;color:rgba(0,0,0,.65)}.hi-select .hi-select-container{color:#333;cursor:default;display:flex;outline:0;overflow:hidden;position:relative;width:100%}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value .ng-value-icon{display:inline-block;padding:0 5px;cursor:pointer}*,::after,::before{box-sizing:border-box}.hi-select.hi-select-multiple .hi-select-container .ng-value-container .ng-value .ng-value-label{display:inline-block;padding:0 5px}.hi-select .hi-select-container .ng-value-container .ng-input>input{box-sizing:content-box;background:0 0;border:0;box-shadow:none;outline:0;cursor:default;width:100%}.hi-select .hi-select-container .ng-input input{color:rgba(0,0,0,.65);line-height:22px}button,input{overflow:visible}button,input,optgroup,select,textarea{margin:0;font-family:inherit;font-size:inherit;line-height:inherit}*,::after,::before{box-sizing:border-box}.ng-dropdown-panel.hi-select-bottom{top:100%;border-top-color:#f3f2f2}.ng-dropdown-panel{background-color:#fff;box-shadow:0 2px 8px rgba(0,0,0,.15);border-radius:4px;margin-top:4px;margin-bottom:4px;left:0}.ng-dropdown-panel{box-sizing:border-box;position:absolute;opacity:0;width:100%;z-index:1050;-webkit-overflow-scrolling:touch}.ng-dropdown-panel .scroll-host{overflow:hidden;overflow-y:auto;position:relative;display:block;-webkit-overflow-scrolling:touch}.ng-dropdown-panel .ng-dropdown-panel-items{display:block;height:auto;box-sizing:border-box;max-height:240px;overflow-y:auto}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option:first-child{border-top-right-radius:4px;border-top-left-radius:4px}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{background-color:#fff;color:rgba(0,0,0,.65);padding:5px 12px;transition:background .3s ease}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{box-sizing:border-box;cursor:pointer;display:block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-disabled{color:rgba(0,0,0,.25);cursor:not-allowed}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{background-color:#fff;color:rgba(0,0,0,.65);padding:5px 12px;transition:background .3s ease}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{box-sizing:border-box;cursor:pointer;display:block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-selected{background-color:#fafafa;font-weight:600}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{background-color:#fff;color:rgba(0,0,0,.65);padding:5px 12px;transition:background .3s ease}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{box-sizing:border-box;cursor:pointer;display:block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{background-color:#e6f7ff;color:rgba(0,0,0,.65)}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{background-color:#fff;color:rgba(0,0,0,.65);padding:5px 12px;transition:background .3s ease}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option{box-sizing:border-box;cursor:pointer;display:block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.ng-dropdown-panel .ng-dropdown-panel-items .ng-option .ng-option-label{font-size:14px}.ng-dropdown-panel.hi-select-top{bottom:100%;border-bottom-color:#f3f2f2}.ng-dropdown-panel{background-color:#fff;box-shadow:0 2px 8px rgba(0,0,0,.15);border-radius:4px;margin-top:4px;margin-bottom:4px;left:0}.ng-dropdown-panel{box-sizing:border-box;position:absolute;opacity:0;width:100%;z-index:1050;-webkit-overflow-scrolling:touch}.hi-select .ng-arrow-wrapper{width:16px;height:26px;transition:transform .3s;cursor:pointer;position:relative;text-align:center;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.hi-select.hi-select-opened>.hi-select-container .ng-arrow-wrapper{transform:rotate(180deg);opacity:1}.hi-select .ng-arrow-wrapper .ng-arrow{position:relative;pointer-events:none;display:inline-block;border-style:solid;border-width:.1rem .1rem 0 0;height:8px;width:8px;top:2px;transform:rotate(135deg);color:rgba(0,0,0,.25)}.hi-select .ng-clear-wrapper{opacity:0;color:#a6a6a6;background:rgba(0,0,0,.25);width:12px;height:12px;text-align:center;border-radius:12px;vertical-align:middle;transition:color .3s ease;right:13px;cursor:pointer;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}\n  "],
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return SelectComponent_1; }),
                    multi: true
                }, SelectService],
            encapsulation: ViewEncapsulation.None,
            changeDetection: ChangeDetectionStrategy.OnPush,
            host: {
                'role': 'listbox',
                'class': 'hi-select',
                '[class.hi-select-single]': '!multiple',
            }
        }),
        __param(0, Attribute('class')),
        __param(1, Attribute('autofocus')),
        __param(3, Inject(SELECTION_MODEL_FACTORY)),
        __metadata("design:paramtypes", [String, Object, NgSelectConfig, Function, ElementRef,
            ChangeDetectorRef])
    ], SelectComponent);
    return SelectComponent;
}());
export { SelectComponent };
