var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, Input, TemplateRef } from '@angular/core';
import { escapeHTML } from './select.utils';
var NgItemLabelDirective = (function () {
    function NgItemLabelDirective(element) {
        this.element = element;
        this.escape = true;
    }
    NgItemLabelDirective.prototype.ngOnChanges = function (changes) {
        this.element.nativeElement.innerHTML = this.escape ?
            escapeHTML(this.ngItemLabel) :
            this.ngItemLabel;
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], NgItemLabelDirective.prototype, "ngItemLabel", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], NgItemLabelDirective.prototype, "escape", void 0);
    NgItemLabelDirective = __decorate([
        Directive({ selector: '[ngItemLabel]' }),
        __metadata("design:paramtypes", [ElementRef])
    ], NgItemLabelDirective);
    return NgItemLabelDirective;
}());
export { NgItemLabelDirective };
var NgOptionTemplateDirective = (function () {
    function NgOptionTemplateDirective(template) {
        this.template = template;
    }
    NgOptionTemplateDirective = __decorate([
        Directive({ selector: '[ng-option-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgOptionTemplateDirective);
    return NgOptionTemplateDirective;
}());
export { NgOptionTemplateDirective };
var NgOptgroupTemplateDirective = (function () {
    function NgOptgroupTemplateDirective(template) {
        this.template = template;
    }
    NgOptgroupTemplateDirective = __decorate([
        Directive({ selector: '[ng-optgroup-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgOptgroupTemplateDirective);
    return NgOptgroupTemplateDirective;
}());
export { NgOptgroupTemplateDirective };
var NgLabelTemplateDirective = (function () {
    function NgLabelTemplateDirective(template) {
        this.template = template;
    }
    NgLabelTemplateDirective = __decorate([
        Directive({ selector: '[ng-label-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgLabelTemplateDirective);
    return NgLabelTemplateDirective;
}());
export { NgLabelTemplateDirective };
var NgMultiLabelTemplateDirective = (function () {
    function NgMultiLabelTemplateDirective(template) {
        this.template = template;
    }
    NgMultiLabelTemplateDirective = __decorate([
        Directive({ selector: '[ng-multi-label-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgMultiLabelTemplateDirective);
    return NgMultiLabelTemplateDirective;
}());
export { NgMultiLabelTemplateDirective };
var NgHeaderTemplateDirective = (function () {
    function NgHeaderTemplateDirective(template) {
        this.template = template;
    }
    NgHeaderTemplateDirective = __decorate([
        Directive({ selector: '[ng-header-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgHeaderTemplateDirective);
    return NgHeaderTemplateDirective;
}());
export { NgHeaderTemplateDirective };
var NgFooterTemplateDirective = (function () {
    function NgFooterTemplateDirective(template) {
        this.template = template;
    }
    NgFooterTemplateDirective = __decorate([
        Directive({ selector: '[ng-footer-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgFooterTemplateDirective);
    return NgFooterTemplateDirective;
}());
export { NgFooterTemplateDirective };
var NgNotFoundTemplateDirective = (function () {
    function NgNotFoundTemplateDirective(template) {
        this.template = template;
    }
    NgNotFoundTemplateDirective = __decorate([
        Directive({ selector: '[ng-notfound-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgNotFoundTemplateDirective);
    return NgNotFoundTemplateDirective;
}());
export { NgNotFoundTemplateDirective };
var NgTypeToSearchTemplateDirective = (function () {
    function NgTypeToSearchTemplateDirective(template) {
        this.template = template;
    }
    NgTypeToSearchTemplateDirective = __decorate([
        Directive({ selector: '[ng-typetosearch-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgTypeToSearchTemplateDirective);
    return NgTypeToSearchTemplateDirective;
}());
export { NgTypeToSearchTemplateDirective };
var NgLoadingTextTemplateDirective = (function () {
    function NgLoadingTextTemplateDirective(template) {
        this.template = template;
    }
    NgLoadingTextTemplateDirective = __decorate([
        Directive({ selector: '[ng-loadingtext-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgLoadingTextTemplateDirective);
    return NgLoadingTextTemplateDirective;
}());
export { NgLoadingTextTemplateDirective };
var NgTagTemplateDirective = (function () {
    function NgTagTemplateDirective(template) {
        this.template = template;
    }
    NgTagTemplateDirective = __decorate([
        Directive({ selector: '[ng-tag-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgTagTemplateDirective);
    return NgTagTemplateDirective;
}());
export { NgTagTemplateDirective };
var NgLoadingSpinnerTemplateDirective = (function () {
    function NgLoadingSpinnerTemplateDirective(template) {
        this.template = template;
    }
    NgLoadingSpinnerTemplateDirective = __decorate([
        Directive({ selector: '[ng-loadingspinner-tmp]' }),
        __metadata("design:paramtypes", [TemplateRef])
    ], NgLoadingSpinnerTemplateDirective);
    return NgLoadingSpinnerTemplateDirective;
}());
export { NgLoadingSpinnerTemplateDirective };
